package gr.uoi.cs.privacy.gui;

import gr.uoi.cs.privacy.network.SmallWorld;
import gr.uoi.cs.privacy.network.draw.Dot;
import gr.uoi.cs.privacy.network.draw.Gml;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;

@SuppressWarnings("serial")
public class MainWindow extends JFrame{
	JTextArea jNode;
	JTextArea jNeighbor;
	JTextArea jProb;
	JButton jOk;
	JButton jCancel;
	
	public MainWindow(){
		initialize();
		draw();
	}
	
	private void initialize() {
		// look and feel
		try {
			javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		JPanel panel = new JPanel();
		
		panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		panel.setLayout(new GridLayout(4, 2, 5, 5));
		
		panel.add(new JLabel("Nodes #"));
		jNode = new JTextArea();
		panel.add(jNode);
		panel.add(new JLabel("Neighbors #"));
		jNeighbor = new JTextArea();
		panel.add(jNeighbor);
		panel.add(new JLabel("Propability"));
		jProb = new JTextArea();
		panel.add(jProb);
		jOk = new JButton("OK");
		jOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				int N = Integer.parseInt(jNode.getText());
				int K = Integer.parseInt(jNeighbor.getText());;
				double p = Float.parseFloat(jProb.getText());;
				SmallWorld sw = new SmallWorld(N, K, p);
				int adj[][] = sw.getAdjMatrix();
				Gml.printToGML(adj, N, N);
				Dot.printToDOT(adj, N, N);
				try {
					Runtime.getRuntime().exec("dot -Tpng out.dot -o out.png").waitFor();
					Runtime.getRuntime().exec("eog out.png");
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		jCancel = new JButton("Cancel");
		jCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				System.exit(0);
			}
		});
		panel.add(jCancel);
		panel.add(jOk);
		
		add(panel);

		setTitle("Small World");
//        setSize(350, 300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLocationRelativeTo(null);
	}
	
	private void draw() {
		pack();
		// center on screen
		Toolkit toolkit = getToolkit();
		Dimension size = toolkit.getScreenSize();
		setLocation(size.width/2 - getWidth()/2, 
		            size.height/2 - getHeight()/2);
	}
}
