package gr.uoi.cs.privacy.network;

import java.util.Vector;

public class RingLattice extends Network {
	protected int K;

	public RingLattice(int N, int K) {
		super(N);
		this.K = K;
		for (int i = 0; i < N; i++){
			Node n = new Node(i,Integer.toString(i));
			this.addNode(n);
		}
		
		for (int i = 0; i < N; i++){
			for (int j = i+1; j < N; j++){
				int abDist = Math.abs(i-j);
				if (N-(abDist+1) < K/2 || abDist <= K/2)  {
					Vector<Node> v = this.getNodes();
					Edge e1 = new Edge(v.get(i), v.get(j));
					Edge e2 = new Edge(v.get(j), v.get(i));
					this.addEdge(e1);
					this.addEdge(e2);
				}
			}
		}
	}
}
